import Metal
import MetalKit

class LoadModel : VexilModel {
	init?(device:MTLDevice,fileName:String) {
        super.init(device:device)
		var dataList:[[String]] = []

		let path = Bundle.main.path(forResource: fileName, ofType: "csv")!
		if let data = NSData(contentsOfFile: path){
			let csvData = String(NSString(data: data as Data, encoding: String.Encoding.utf8.rawValue)!)
			let csvList:[String] = csvData.components(separatedBy:"\n")
			for i in 0..<csvList.count {
				dataList.append([])
				dataList[i] = csvList[i].components(separatedBy:",")
			}
		} else {
			print("Error")
		}
		for i in 0..<dataList.count {
			if dataList[i][0] == "B" {
				_maxBonesSize = NSString(string:dataList[i][1]).integerValue
				break
			}
		}

		var flg:Int = 0
		for i in 0..<dataList.count {
			if dataList[i][0] == "V" {
				_vertices.append([])
				for j in 1..<dataList[i].count {
					_vertices[flg].append(NSString(string:dataList[i][j]).floatValue)
				}
				flg += 1
			}
		}
		
		flg = 0
		for i in 0..<dataList.count {
			if dataList[i][0] == "A" {
				_matricies.append([])
				_animationNames[dataList[i][1]] = flg
				for j in 2..<dataList[i].count {
					_matricies[flg].append(NSString(string:dataList[i][j]).floatValue)
				}
				flg += 1
			}
		}
		
       	super.initialize(device:device)
		
		for i in 0..<dataList.count {
			if dataList[i][0] == "M" {
				super.setMaterial(
					texture:dataList[i][1],
					red:NSString(string:dataList[i][2]).floatValue,
					green:NSString(string:dataList[i][3]).floatValue,
					blue:NSString(string:dataList[i][4]).floatValue,
					alpha:NSString(string:dataList[i][5]).floatValue)
			}
		}

		flg = 0
		for i in 0..<dataList.count {
			if dataList[i][0] == "T" {
				_materials.append([])
				for j in 1..<dataList[i].count {
					_materials[flg].append(NSString(string:dataList[i][j]).integerValue)
				}
				flg += 1
			}
		}
	}
}
